'use strict';

var CurvaABCItemCompraController = angular.module('CurvaABCItemCompraController', []);

CurvaABCItemCompraController.controller('CurvaABCItemCompraCtrl', ['$scope', '$filter', '$routeParams', 'Relatorio', 'Material', 'Solicitacao', 'Construcao', 'UploadApp', 'CacheApp',
  function ($scope, $filter, $routeParams, Relatorio, Material, Solicitacao, Construcao, UploadApp, CacheApp) {

    $scope.getSelectedTipo = function () {
        return { Id: 0, Descricao: "Todos os Insumos" };
    }
    $scope.getSelectedMedicao = function () {
        return { Id: 0, Descricao: "Todas as Medições" };
    }

    $scope.getRelatorioCurvaABCMedicaoItem = function () {
        $scope.curvaABC = [];
        $scope.listaItens = [];
        Relatorio.getRelatorioCurvaABCMedicaoItem($scope.relatorio,
            function (data) {
                $scope.curvaABC = data.Instance;
            });
    }

    $scope.getTipoMaterial = function () {
        Material.getTipoMaterial(
            function (data) {
                $scope.listaTipoMaterial = data.Instance;
                $scope.listaTipoMaterial.unshift($scope.getSelectedTipo());
            });
    }

    $scope.getMedicoes = function () {
        Relatorio.getMedicoes($scope.construcao.Id,
            function (data) {
                $scope.medicoes = data.Instance;
                $scope.medicoes.unshift($scope.getSelectedMedicao());
            });
    }

    $scope.changeTipo = function () {
        $scope.formulario.Tipo = $scope.selecionado.Tipo.Descricao;
        $scope.relatorio.Tipo = $scope.selecionado.Tipo.Id;
        $scope.getRelatorioCurvaABCMedicaoItem();
    }

    $scope.changeMedicao = function () {
        $scope.formulario.Medicao = $scope.selecionado.Medicao.Descricao;
        $scope.relatorio.Medicao = $scope.selecionado.Medicao.Id;
        $scope.getRelatorioCurvaABCMedicaoItem();
    }

    $scope.pdfRelatorioCurvaABCMedicaoItem = function () {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta + ' - ' + $scope.formulario.Medicao + ' - ' + $scope.formulario.Tipo,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        };

        Relatorio.pdfRelatorioCurvaABCMedicaoItem($scope.relatorio, cabecalho,
            function (data) {
                window.location.assign(data.Instance);
            });
    }

    $scope.adicionaLista = (item) => {
        item.Selecionado = !item.Selecionado;
        if ($scope.listaItens.filter(i => i == item).length == 0)
            $scope.listaItens.push(item);
        else
            $scope.listaItens.splice($scope.listaItens.indexOf(item));
    }
    
    $scope.marcarTodos = (marcar) => {
        $scope.curvaABC.filter(c=> c.IdMaterial).forEach(item => {
            if (item.Selecionado && !marcar)
                $scope.listaItens.splice($scope.listaItens.indexOf(item));

            if (!item.Selecionado && marcar)
                $scope.listaItens.push(item);

            item.Selecionado = marcar;
        })
    }

    $scope.abrirSolicitacaoCompra = () => {

        var selectAbrir = `<div align="center"><select id="Prioridade" style="width:160px;" class="form-control" ng-model="2" ng-init="2 + """>`;
        var selectFechar = '</select></div>'
        var option = `<option value="" disabled> Prioridade </option> <option value="1">Baixa</option> <option value="2" selected>Média</option> <option value="3">Alta</option>`;
        var selectMontado = selectAbrir + option + selectFechar

        swal({
            title: `Solicitação de Compra`,
            html: ''+
            '<label>Data Limite</label><br>'+
            '<center><input type="date" style="width:160px;" id="DataLimite" class="form-control" required datasafari /></center><br>' +
            '<label>Prioridade</label><br>'+ selectMontado,
            showCancelButton: true,
            confirmButtonColor: '#263143',
            cancelButtonColor: '#F6A000',
            confirmButtonText: 'Enviar',
            cancelButtonText: "Cancelar",
            onOpen: () => {
                $('#DataLimite').val( $filter("date")(Date.now(), 'yyyy-MM-dd') );//item.Data;
            }
          }).then((result) => {
            if (result.value) {
                var dataLimite = $('#DataLimite').val();
                var prioridade = $('#Prioridade').val();

                var solicitacao = {
                    IdSolicitacao: 0,
                    IdConstrucao: $scope.construcao.Id,
                    IdSolicitacaoWorkflow: 0,
                    IdSolicitacaoSituacao: 0,
                    IdClienteFuncionario: $scope.sessao.IdCliente,
                    Texto: '',
                    Data: CacheApp.getData($filter("date")(dataLimite, 'yyyy-MM-ddT06:05:00Z')),
                    Prioridade: prioridade,
                    Chave: 'GET_COMPRA_SOLICITACAO',
                    listaInsumo: [],
                };

                $scope.listaItens.forEach(i => {
                    solicitacao.listaInsumo.push({
                        IdSolicitacaoItem: 0,
                        IdSolicitacao: 0,
                        IdMaterial: i.IdMaterial, 
                        IdEtapa: undefined,
                        IdComposicao: undefined,
                        QuantidadeSolicitada: i.Quantidade
                    });
                });

                $scope.salvarSolicitacao(solicitacao);
            }
          });
    }

    $scope.salvarSolicitacao = (solicitacao) => {
        if (solicitacao.listaInsumo.length == 0) {
            $scope.msgBoxAtencao('Atenção!','A solicitação precisa conter pelo menos um item.',() => {});
            return;
        }

        var params = {
            IdSolicitacao: 0,
            IdConstrucao: solicitacao.IdConstrucao,
            IdSolicitacaoWorkflow: solicitacao.IdSolicitacaoWorkflow,
            IdSolicitacaoSituacao: solicitacao.IdSolicitacaoSituacao,
            IdClienteFuncionario: solicitacao.IdClienteFuncionario,
            Texto: solicitacao.Texto,
            Data: solicitacao.Data,
            Prioridade: solicitacao.Prioridade
        }
        Solicitacao.setSolicitacao(params,
            (result) => {
                solicitacao.IdSolicitacao = result.Instance.IdSolicitacao;
                var itensSolicitacao = [];
                solicitacao.listaInsumo.forEach(
                    l => {
                        itensSolicitacao.push({
                                IdSolicitacaoItem: 0,
                                IdSolicitacao: solicitacao.IdSolicitacao,
                                IdMaterial: l.IdMaterial,
                                IdEtapa: l.IdEtapa,
                                IdComposicao: l.IdComposicao,
                                QuantidadeSolicitada: l.QuantidadeSolicitada
                            }
                        );
                    }
                );

                Solicitacao.setSolicitacaoListaItens(itensSolicitacao, (result1) => {
                    setTimeout(() => {
                        $scope.msgBoxSucesso('Solicitação Registrada','Solicitação incluída com sucesso!',() => {});
                    }, 1000);
                });
            }
        );
    }

    $scope.getEtapasConstrucao = function () {
        $scope.etapas = [];
        Construcao.getEtapasConstrucao($scope.construcao.Id,
            function (data) {
                $scope.etapas = data.Instance;
            });
    }

    $scope.getListaComposicao = (IdEtapa) => {
        $scope.relatorio.IdComposicao = '0';
        $scope.changeTipo();
        Material.getListaMaterialAvanco(
            $scope.construcao.Id,
            IdEtapa,
            '',
            (data) => {
                $scope.composicoes = data.Instance;
            }
        );
    }

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.AcessoMobile = sim;
        $scope.construcao = CacheApp.getConstrucao();

        $scope.selecionado = { Tipo: $scope.getSelectedTipo(), Medicao: $scope.getSelectedMedicao() };
        $scope.formulario = { Tipo: $scope.getSelectedTipo().Descricao, Medicao: $scope.getSelectedMedicao().Descricao };
        $scope.relatorio = { IdConstrucao: $scope.construcao.Id, Tipo: 0, Medicao: 0, IdEtapa: 0, IdComposicao: 0 };

        $scope.getRelatorioCurvaABCMedicaoItem();
        $scope.getTipoMaterial();
        $scope.getMedicoes();
        $scope.getEtapasConstrucao();
    });

}]);
